# CodingToolBox

## github:
[CodingToolBox](https://github.com/kent010341/CodingToolBox)

## Requires:
* Python 3.6 (or above)
* numpy

## Update dialog
* 1.0.0: Upload package.
* 1.1.0: Add two methods: ask_file_popup, ask_folder_popup
* 1.2.0: Add method: install_checker
  * 1.2.1: Edit copy in var_form.
  * 1.2.2: Fix init bug.
  * 1.2.3: Fix bug at DetailRecorder.
  * 1.2.4: Fix bug at DetailRecorder.
* 1.3.0: Add method: cal_SNR.
  * 1.3.1: Fix bug at cal_SNR.
  * 1.3.2: Use importlib.util.find_spec instead of ModuleNotFoundError. 
* 1.4.0: Add module: TorchLoss, contains various of loss function including MSE, RMSE, MAPE, MAE, SNR and SSIM.
* 2.0.0: Rewrite library, remove AnimatedPlot.
  * 2.0.1: Fixed bug.

## Lib Description 
* Descriptions and demos are at [CodingToolBox](https://github.com/kent010341/CodingToolBox).

## Lib Structure
* CodingToolBox
  * [get_peak](https://github.com/kent010341/CodingToolBox/blob/master/documents/get_peak.md): Get indices and values of peaks of periodical signal by **automatic multiscale-based peak detection (AMPD)** algorithm.
  * [DetailRecorder](https://github.com/kent010341/CodingToolBox/blob/master/documents/DetailRecorder.md): Convenient recording tool.
  * [raw_var](https://github.com/kent010341/CodingToolBox/blob/master/documents/raw_var.md): Return raw variable string that can easily be used in another script.
  * [TkMethods](https://github.com/kent010341/CodingToolBox/blob/master/documents/TkMethods.md): Methods based on tkinter.
    * ask_file: Popup menu for asking file location.
    * ask_folder: Popup menu for asking folder location.
  * [Math](https://github.com/kent010341/CodingToolBox/blob/master/documents/Math.md): Math module.
    * norm_p: Return norm.
    * sqrt: Support negative value.
  * [NpLoss](https://github.com/kent010341/CodingToolBox/blob/master/documents/NpLoss%20and%20TorchLoss.md): Loss function (NumPy version).
    * MAE: mean absulate error.
    * MAPE: mean absolute percentage error.
    * MSE: mean square error.
    * RMSE: root mean square error.
    * SNR: signal-to-noise ratio.
    * SSIM: structural similarity index.
  * [TorchLoss](https://github.com/kent010341/CodingToolBox/blob/master/documents/NpLoss%20and%20TorchLoss.md): Loss function (PyTorch version).
    * MAE: mean absulate error.
    * MAPE: mean absolute percentage error.
    * MSE: mean square error.
    * RMSE: root mean square error.
    * SNR: signal-to-noise ratio.
    * SSIM: structural similarity index.